	.include "forth.inc"

	.macro de name, code_addr
	.byte 1f-0f    #length byte
0:	.byte "\name"  #name string
1:	.ifgt 0b+MAX_NAME_LEN-.  #name padding
	.space 0b+MAX_NAME_LEN-.
	.endif
	.int \code_addr
	.endm

	dict

	.global forth_dict_start, forth_dict_length
forth_dict_start:
	de "execute", f_execute
	de "compile-far", f_compile_far
	de "compile", f_compile
	de "+", f_plus
	de "-", f_minus
	de "*", f_star
	de "/", f_slash
	de "negate", f_negate
	de "abs", f_abs
	de "min", f_min
	de "max", f_max
	de "and", f_and
	de "or", f_or
	de "xor", f_xor
	de "not", f_not
	de "dup", f_dup
	de "drop", f_drop
	de "swap", f_swap
	de "over", f_over
	de "push", f_push
	de "pop", f_pop
	de "r@", f_r_fetch
	de "rdrop", f_rdrop
	de "here", f_here
	de "allot", f_allot
	de "align", f_align
	de ",", f_comma
	de "c,", f_c_comma
	de "a", f_a
	de "a!", f_a_store
	de "@a", f_fetch_a
	de "!a", f_store_a
	de "@a+", f_fetch_a_plus
	de "!a+", f_store_a_plus
	de "c@a", f_c_fetch_a
	de "c!a", f_c_store_a
	de "cnt", f_cnt
	de "emit", f_emit
	de "type", f_type
	de "key", f_key
	de "word", f_word
	de "parse", f_parse
	de "compile?", f_compile_q
	de "]", f_close_bracket
	de "]l", f_close_bracket_l
	de "find", f_find
	de "ffind", f_ffind
	de "cfind", f_cfind
	de "define", f_define
	de "forth", f_forth
	de "compiler", f_compiler
	de "flush", f_flush
	de "flush-1", f_flush_1
	de ":", f_colon
	de "const", f_const
	de "var", f_var
	de "create", f_create
	de "bye", f_bye
	de "err", f_err
	de "not-found", word_not_found
	de "base", f_base
	de ">num?", f_to_num_q
	de "u.", f_u_dot
	de ".", f_dot
	de "=", f_equals
	de "lshift", f_lshift
	de "rshift", f_rshift

	.set forth_dict_length,.-forth_dict_start


	.global compiler_dict_start,compiler_dict_length
compiler_dict_start:

	de "lit16", m_lit16
	de "literal", m_literal
	de "lit32", m_lit32

	de "[", m_open_bracket
	de "postpone", m_postpone

	de "if", m_if
	de "unless", m_unless
	de "else", m_else
	de "then", m_then

	de "for", m_for
	de "next", m_next

	de "begin", m_begin
	de "again", m_again

	.byte 1f-0f
0:	.byte 's', '"'
1:	.space 0b+MAX_NAME_LEN-.
	.int m_s_quote

	de ":", f_colon

	.byte 1f-0f
0:	.byte ";"
1:	.space 0b+MAX_NAME_LEN-.
	.int m_semicolon

	.set compiler_dict_length,.-compiler_dict_start
