#words.s - word definitions for our basic forth.

	.include "forth.inc"
	.include "asm.inc"

	code

	.global f_execute
f_execute:
	prolog
	lwz tos,CODE_PTR(tos)
	mtctr tos
	drop
	bctrl
	epilog

	.global f_compile_far
f_compile_far:
	prolog
	lwz tos,CODE_PTR(tos)
	bl m_literal
	liwl r3,_mtctr_tos
	liwl r4,_bctrl
	stw r3,0(here)
	stw r4,4(here)
	addi here,here,8
	epilog

	.global f_compile
f_compile:
	lwz r3,CODE_PTR(tos)
	sub r3,r3,here
	srawi. r4,r3,26
	beq 0f
	cmpwi r4,-1
	bne f_compile_far
0:	drop
	li_bl r4,r3
	stw r4,0(here)
	addi here,here,4
	blr

	.global f_plus
f_plus:
	nip r3
	add tos,r3,tos
	blr

	.global f_minus
f_minus:
	nip r3
	sub tos,r3,tos
	blr

	.global f_star
f_star:
	nip r3
	mullw tos,r3,tos
	blr

	.global f_slash
f_slash:
	nip r3
	divw tos,r3,tos
	blr

	.global f_negate
f_negate:
	neg tos,tos
	blr

	.global f_abs
f_abs:
	cmpwi tos,0
	bgelr
	neg tos,tos
	blr

	.global f_min
f_min:
	nip r3
	cmpw r3,tos
	bgelr
	mr tos,r3
	blr

	.global f_max
f_max:
	nip r3
	cmpw r3,tos
	blelr
	mr tos,r3
	blr

	.global f_and
f_and:
	nip r3
	and tos,r3,tos
	blr

	.global f_or
f_or:
	nip r3
	or tos,r3,tos
	blr

	.global f_xor
f_xor:
	nip r3
	xor tos,r3,tos
	blr

	.global f_not
f_not:
	not tos,tos
	blr

	.global f_dup
f_dup:
	dup
	blr

	.global f_drop
f_drop:
	drop
	blr

	.global f_swap
f_swap:
	lwz r3,0(ds)
	stw tos,0(ds)
	mr tos,r3
	blr

	.global f_over
f_over:
	dup
	lwz tos,4(ds)
	blr

	.global f_push
f_push:
	push tos
	drop
	blr

	.global f_pop
f_pop:
	dup
	pop tos
	blr

	.global f_r_fetch
f_r_fetch:
	dup
	lwz tos,0(rs)
	blr

	.global f_rdrop
f_rdrop:
	addi rs,rs,4
	blr

	.global f_here
f_here:
	dup
	mr tos,here
	blr

	.global f_allot
f_allot:
	add here,here,tos
	drop
	blr

	.global f_align
f_align:
	addi here,here,3
	clrrwi here,here,2
	blr

	.global f_comma
f_comma:
	stw tos,0(here)
	addi here,here,4
	drop
	blr

	.global f_c_comma
f_c_comma:
	stb tos,0(here)
	addi here,here,1
	drop
	blr

	.global f_a
f_a:
	dup
	mr tos,a
	blr

	.global f_a_store
f_a_store:
	mr a,tos
	drop
	blr

	.global f_fetch_a
f_fetch_a:
	dup
	lwz tos,0(a)
	blr

	.global f_store_a
f_store_a:
	stw tos,0(a)
	drop
	blr

	.global f_fetch_a_plus
f_fetch_a_plus:
	dup
	lwz tos,0(a)
	addi a,a,4
	blr

	.global f_store_a_plus
f_store_a_plus:
	stw tos,0(a)
	addi a,a,4
	drop
	blr

	.global f_c_fetch_a
f_c_fetch_a:
	dup
	lbz tos,0(a)
	blr

	.global f_c_store_a
f_c_store_a:
	stb tos,0(a)
	drop
	blr

	.global f_cnt
f_cnt:
	dup
	mfctr tos
	blr

	.global f_key
f_key:
	prolog
	liw r3,input
	lwz r4,in_cur(r3)
	lwz r5,in_len(r3)
	cmpw r4,r5
	blt 0f
	bl f_refill
	liw r3,input
	lwz r4,in_cur(r3)
0:	lwz r5,in_buf(r3)
	dup
	lbzx tos,r5,r4
	addi r4,r4,1
	stw r4,in_cur(r3)
	epilog

	.global f_word
f_word:		#( "<spaces>ccc<space>" -- c-addr u )
	prolog
	dup
	mr tos,here
0:	bl f_key	#skip initial whitespace
	cmpwi tos,' '
	bgt 2f
	drop
	b 0b
1:	bl f_key	#get word
2:	mr r3,tos
	drop
	stbu r3,1(tos)
	cmpwi r3,' '
	bgt 1b
	sub r3,tos,here	#compute and store length byte
	subi r3,r3,1
	stb r3,0(here)
	addi tos,here,1	#return c-addr u
	dup
	mr tos,r3
	epilog

	.global f_parse
f_parse:	#( char "ccc<char>" -- c-addr u )
	prolog
	stb tos,0(here)
	mr tos,here
0:	bl f_key	#parse word
	mr r3,tos
	drop
	stbu r3,1(tos)
	lbz r4,0(here)
	cmpw r3,r4
	bne 0b
	sub r3,tos,here	#compute and store length byte
	subi r3,r3,1
	stb r3,0(here)
	addi tos,here,1	#return c-addr u
	dup
	mr tos,r3
	epilog

	.global f_compile_q
f_compile_q:	#( -- flag )
	dup
	lwz tos,state(toc)
	blr

	.global f_close_bracket
f_close_bracket:
	li r3,COMPILE
	stw r3,state(toc)
	blr

	.global f_close_bracket_l
f_close_bracket_l:
	li r3,COMPILE
	stw r3,state(toc)
	b m_literal

	.global f_find
f_find:		#( c-addr u dict -- xt true | c-addr u false )
	lwz r3,D_FREE(tos)
	lwz r4,D_BASE(tos)
	drop
	# ( c-addr u -- xt true | c-addr u false )
0:	subi r3,r3,DICT_ENTRY_SIZE
	cmpw r3,r4
	bge 1f
	#not found
	dup
	li tos,0
	blr
1:	lbz r5,0(r3)	#check lengths
	cmpw r5,tos
	bne 0b		#don't match; check next name
	mtctr tos	#lengths match; check rest of name
	mr r5,r3
	lwz r6,0(ds)
	subi r6,r6,1
2:	lbzu r7,1(r5)
	lbzu r8,1(r6)
	cmpw r7,r8
	bne 0b		#char mismatch; check next name
	bdnz 2b
	#found!
	stw r3,0(ds)
	li tos,-1
	blr

	.global f_ffind
f_ffind:	#( c-addr u -- xt true | c-addr u false )
	dup
	addi tos,toc,forth_dict
	b f_find

	.global f_cfind
f_cfind:	#( c-addr u -- xt true | c-addr u false )
	dup
	addi tos,toc,compiler_dict
	b f_find

	.global f_define
f_define:	#( c-addr u -- )
	lwz r3,current_dict(toc)
	lwz r4,D_FREE(r3)
	mr r7,r4
	#set name
	cmpwi tos,MAX_NAME_LEN
	ble 0f
	li tos,MAX_NAME_LEN
0:	nip r5
	addi r5,r5,-1
	stb tos,0(r4)
	mtctr tos
1:	lbzu r6,1(r5)
	stbu r6,1(r4)
	bdnz 1b
	#set code address
	addi here,here,3	#align
	clrrwi here,here,2
	stw here,CODE_PTR(r7)
	addi r7,r7,DICT_ENTRY_SIZE
	stw r7,D_FREE(r3)
	drop
	blr

	.global f_forth
f_forth:
	addi r3,toc,forth_dict
	stw r3,current_dict(toc)
	blr

	.global f_compiler
f_compiler:
	addi r3,toc,compiler_dict
	stw r3,current_dict(toc)
	blr

	.global f_flush
f_flush:
	lwz r3,flushed_to(toc)
	#compute number of cache lines to flush
	clrrwi r3,r3,5	#align addr to next lower cache line boundary
	subf r4,r3,here #then lines = (len + 0x1f) / 0x20
	addi r4,r4,0x1f
	srwi. r4,r4,5
	beqlr
	mtctr r4
0:	dcbf r0,r3
	sync
	icbi r0,r3
	addi r3,r3,0x20
	bdnz 0b
	sync
	isync
	stw here,flushed_to(toc)
	blr

	.global f_flush_1
f_flush_1:
	dcbf r0,tos
	sync
	icbi r0,tos
	sync
	isync
	drop
	blr

	.global f_colon
f_colon:
	prolog
	bl f_word
	bl f_define
	liwl r3,_mflr_r0  #assemble prolog
	liwl r4,_rpush_r0
	stw r3,0(here)
	stw r4,4(here)
	addi here,here,8
	li r3,COMPILE  #change state to compile
	stw r3,state(toc)
	epilog

	.global f_const
f_const:
	prolog
	bl f_word
	bl f_define
	bl m_literal
	liwl r3,_blr
	stw r3,0(here)
	addi here,here,4
	bl f_flush
	epilog

	.global f_var
f_var:
	prolog
	bl f_word
	bl f_define
	liwl r3,_dup
	lwz r4,var_here(toc)	#addi tos,toc,var_offset
	subi r6,r4,4		#(and update var_here)
	stw r6,var_here(toc)
	clrlwi r4,r4,16
	oris r4,r4,0x39df
	liwl r5,_blr
	stw r3,0(here)
	stw r4,4(here)
	stw r5,8(here)
	addi here,here,12
	bl f_flush
	epilog

	.global f_create
f_create:
	prolog
	bl f_word
	bl f_define
	addi here,here,16
	srwi r4,here,16
	clrlwi r5,here,16
	liwl r3,_dup
	li_liwl_tos r4,r5,here
	liw r6,_blr
	stw r3,0(here)
	stw r4,4(here)
	stw r5,8(here)
	stw r6,12(here)
	epilog

	.global f_base
f_base:
	dup
	addi tos,toc,base
	blr

	.global f_to_num_q
f_to_num_q:		#( c-addr u -- n true | c-addr u false )
	lwz r3,0(ds)
	dup
	#decide what base to use
	lbz r5,0(r3)
	li r7,10
	cmpwi r5,'#'
	beq 0f
	li r7,16
	cmpwi r5,'$'
	beq 0f
	lwz r7,base(toc)
	b 1f
0:	lbzu r5,1(r3)
	subi tos,tos,1
1:	#get sign of number
	li r6,1
	cmpwi r5,'-'
	bne 0f
	neg r6,r6
	lbzu r5,1(r3)
	subi tos,tos,1
0:	mtctr tos
	li tos,0
	li r4,0
1:	cmpwi r5,'0'
	bltlr
	cmpwi r5,'9'
	ble 2f
	cmpwi r5,'a'
	bltlr
	subi r5,r5,'a'-10
	b 3f
2:	subi r5,r5,'0'
3:	cmpw r5,r7
	bgelr		#not a digit in this base
	#add digit to number
	mullw r4,r4,r7
	add r4,r4,r5
	lbzu r5,1(r3)
	bdnz 1b
	mullw r4,r4,r6	#set sign
	addi ds,ds,4	# ( c-addr u false -- n true )
	stw r4,0(ds)
	li tos,-1
	blr

	.global f_u_dot
f_u_dot:
	prolog
	lwz r3,base(toc)
	li r4,0		#mark end of digits
	tuck r4
0:	divwu r4,tos,r3
	mullw r5,r4,r3
	sub r5,tos,r5
	mr tos,r4
	cmpwi r5,10
	addi r5,r5,'0'
	blt 1f
	addi r5,r5,'a'-10-'0'
1:	tuck r5
	cmpwi tos,0
	bne 0b
	drop
2:	bl f_emit
	cmpwi tos,0
	bne 2b
	drop
	epilog

	.global f_dot
f_dot:
	cmpwi tos,0	#check sign, maybe emit '-'
	bge f_u_dot
	neg tos,tos
	dup
	li tos,'-'
	prolog
	bl f_emit
	_epilog
	b f_u_dot

	.global f_equals
f_equals:
	nip r3
	cmpw r3,tos
	li tos,-1
	beqlr
	li tos,0
	blr

	.global f_lshift
f_lshift:
	nip r3
	slw tos,r3,tos
	blr

	.global f_rshift
f_rshift:
	nip r3
	srw tos,r3,tos
	blr


#compiler words

	.global m_lit16
m_lit16:
	liwl r3,_dup
	li_li_tos r4,tos
	stw r3,0(here)
	stw r4,4(here)
	addi here,here,8
	drop
	blr

	.global m_literal, m_lit32
m_literal:
	srawi. r3,tos,15
	beq m_lit16
	cmpwi r3,-1
	beq m_lit16
m_lit32:
	liw r3,_dup
	li_liwl_tos r4,r5,tos
	stw r3,0(here)
	stw r4,4(here)
	addi here,here,8
	clrlwi. r0,r5,16  #maybe assemble ori tos,tos,lit@l
	beq 0f
	stw r5,0(here)
	addi here,here,4
0:	drop
	blr

	.global m_if
m_if:
	lis r3,_cmpwi_tos@h  #cmpwi tos,0
	li_drop r4,r5
	lis r6,_beq@h
	stw r3,0(here)
	stw r4,4(here)
	stw r5,8(here)
	stw r6,12(here)
	addi here,here,16
	dup	#save HERE for patching in branch address later
	subi tos,here,4
	blr

	.global m_unless
m_unless:
	lis r3,_cmpwi_tos@h	#cmpwi tos,0
	li_drop r4,r5
	lis r6,_bne@h
	stw r3,0(here)
	stw r4,4(here)
	stw r5,8(here)
	stw r6,12(here)
	addi here,here,16
	dup	#save HERE for patching in branch address later
	subi tos,here,4
	blr

	.global m_else
m_else:
	lis r3,_b@ha
	stw r3,0(here)
	addi here,here,4
	sub r3,here,tos	#patch bne from IF
	sth r3,2(tos)
	subi r4,here,4	#change saved HERE to be our b, not bne from IF
	tuck r4
	b f_flush_1	#and flush patched instruction

	.global m_then
m_then:
	sub r3,here,tos #patch bne from IF (or b from ELSE)
	sth r3,2(tos)
	b f_flush_1	#and flush patched instruction

	.global m_for
m_for:
	liwl r3,_mtctr_tos
	li_drop r4,r5
	stw r3,0(here)
	stw r4,4(here)
	stw r5,8(here)
	addi here,here,12
	dup		#save address to top of loop
	mr tos,here
	blr

	.global m_next
m_next:
	sub r3,tos,here	#negative branch offset
	drop
	clrlwi r3,r3,16
	oris r3,r3,_bdnz@ha
	stw r3,0(here)
	addi here,here,4
	blr

	.global m_begin
m_begin:
	dup
	mr tos,here
	blr

	.global m_again
m_again:
	sub r3,tos,here
	drop
	clrlwi r3,r3,6
	oris r3,r3,_b@ha
	stw r3,0(here)
	addi here,here,4
	blr

	.global m_open_bracket
m_open_bracket:
	li r3,INTERPRET
	stw r3,state(toc)
	blr

	.global m_postpone
m_postpone:
	li r3,POSTPONE
	stw r3,state(toc)
	blr

	.global m_semicolon
m_semicolon:
	li_rpop_r0 r3,r4
	liwl r5,_mtlr_r0
	liwl r6,_blr
	stw r3,0(here)
	stw r4,4(here)
	stw r5,8(here)
	stw r6,12(here)
	addi here,here,16
	li r3,INTERPRET	#set state back to interpret
	stw r3,state(toc)
	b f_flush

	.global m_s_quote
m_s_quote:
	prolog
	lis r3,_b@h	#branch instruction
	stw r3,0(here)
	dup
	mr tos,here
	addi here,here,4
	dup
	li tos,'"'
	bl f_parse
	lwz r3,0(ds)
	add here,r3,tos
	bl f_align
	lwz r3,4(ds)	#patch branch instruction
	sub r4,here,r3
	sth r4,2(r3)
	bl f_swap
	bl m_lit32
	bl m_lit16
	drop
	epilog
