\ instruction pieces

: opcode $3f and 26 lshift ;
: opcode2 $3ff and 1 lshift ;
: op1 $1f and 21 lshift ;
: op2 $1f and 16 lshift ;
: op3 $1f and 11 lshift ;
: op4 $1f and 6 lshift ;
: op5 $1f and 1 lshift ;
: imm $ffff and ;
: a16 $fffc and ;
: a26 $3fffffc and ;
: spr dup $1f and swap 5 rshift $1f and or 11 lshift ;
: cond op2 swap op1 or ;

\ intermediate words

: rr swap op2 or swap op1 or ;
: rrl swap op1 or swap op2 or ;
: rri opcode swap imm or rr ;
: rril opcode swap imm or rrl ;
: rrr opcode2 $1f opcode or swap op3 or rr ;
: rrrl opcode2 $1f opcode or swap op3 or rrl ;

\ mnemonics

: _add $10a rrr ;
: _addi $e rri ;
: _addis $f rri ;
: _and $1c rrrl ;
: _andc $3c rrrl ;
: _b a26 $12 opcode or ;
: _bc swap a16 or $10 opcode or ;
: _bclr $10 opcode2 or $13 opcode or ;
: _bcctr $210 opcode2 or $13 opcode or ;
: _cmp op3 swap op2 or $1f opcode or ;
: _cmpi imm swap op2 or $b opcode or ;
: _cmpl op3 swap op2 or $1f opcode or $20 opcode2 or ;
: _dcbf op3 swap op2 or $1f opcode or $56 opcode2 or ;
: _divw $1eb rrr ;
: _divwu $1cb rrr ;
: _icbi op3 swap op2 or $1f opcode or $3d6 opcode2 or ;
: _isync $13 opcode $96 opcode2 or ;
: _lbz $22 rri ;
: _lbzu $23 rri ;
: _lhz $28 rri ;
: _lwz $20 rri ;
: _lwzu $21 rri ;
: _mfspr spr swap op1 or $1f opcode or $153 opcode2 or ;
: _mtspr spr swap op1 or $1f opcode or $1d3 opcode2 or ;
: _mullw $eb rrr ;
: _neg 0 $68 rrr ;
: _nor $7c rrrl ;
: _or $1bc rrrl ;
: _ori $18 rri
: _oris $19 rri ;
: _rlwinm $15 opcode swap op5 or swap op4 or swap op3 or rrl ;
: _rlwnm $17 opcode swap op5 or swap op4 or swap op3 or rrl ;
: _sc [ $11 opcode 2 or ]l ;
: _slw $18 rrrl ;
: _srw $218 rrrl ;
: _sraw $318 rrrl ;
: _stb $26 rri ;
: _stbu $27 rri ;
: _sth $2c rri ;
: _stw $24 rri ;
: _stwu $25 rri ;
: _sub swap $28 rrr ;
: _tw 4 rrr ;
: _xor $13c rrrl ;


\ conditions
: _always [ 20 0 cond ]l ;

: _lt [ 12 0 cond ]l ;
: _gt [ 12 1 cond ]l ;
: _eq [ 12 2 cond ]l ;

: _ge [ 4 0 cond ]l ;
: _le [ 4 1 cond ]l ;
: _ne [ 4 2 cond ]l ;

: _dnz [ 16 0 cond ]l ;

\ simplified mnemonics

: _blt _lt _bc ;
: _bgt _gt _bc ;
: _beq _eq _bc ;
: _bge _ge _bc ;
: _ble _le _bc ;
: _bne _ne _bc ;
: _bdnz _dnz _bc ;

: _bl _b 1 or ;
: _bctrl $13 opcode $210 opcode2 or $14 op1 or 1 or ;

: _blr _always _bclr ;
: _beqlr _eq _bclr ;
: _bltlr _lt _bclr ;
: _bctr _always _bcctr ;
: _bctrl _always _bcctr 1 or ;

: _li 0 swap _addi ;
: _lis 0 swap _addis ;
: _mr dup _or ;
: _mtctr 9 _mtspr ;
: _mtlr 8 _mtspr ;
: _mfctr 9 _mfspr ;
: _mflr 9 _mfspr ;
: _not dup _nor ;
: _trap [ 31 0 dup _tw ]l ;
